
# Python counterpart of "winavg.bc"
# author:  Lucas Stevenson
# tweaks by Terence Kelly:
#     harmonize variable names and parameters with "winavg.bc"
#     move final persistence outside main loop

import decimal, shelve, collections, sys, os
decimal.getcontext().prec = 5
w = 3

pf = os.environ.get("PYTHON_PERSIST_FILE", None)
a, sum = collections.deque(maxlen=w), 0
if pf:
    D = shelve.open(pf)
    a, sum = D.get("a", a), D.get("sum", sum)

while (line := sys.stdin.readline().strip()) and (x := decimal.Decimal(line)) != -1:
    sum += x if len(a) < w else x-a[0]
    a.append(x)
    d = min(w, len(a))
    print(f"x: {x}  sum: {sum}  d: {d}  avg: {sum / d}")

if pf:
    D["a"], D["sum"] = a, sum

